package lotos;

import lotos.*; 
import java.io.FileInputStream;
import java.io.InputStream;

/***************************************************************************/
/*       Lotos, an extensible overlay network simulator                    */
/*       MNG Group                                                         */
/*       University of Virginia                                            */
/*       July, 2002                                                        */
/***************************************************************************/

/**
 * 
 * This class manages the access to the file resource
 * 
 * @author Guangyu Dong
 * 
 */
public class FileResourceManager {
	/**
	 * Try to open a local file first, then a file in the package.
	 * @return
	 */
	static public InputStream openFile(String filename){
		try {
			return new FileInputStream(filename);
		} catch (Exception e) {
			System.out.println("Couldn't find "+ filename +" in local directory, use the embedded file instead.");
			return FileResourceManager.class.getResourceAsStream(filename);
		}
	}
}
