/***************************************************************************/
/*       Lotos, an extensible overlay network simulator                    */
/*       MNG Group                                                         */
/*       University of Virginia                                            */
/*       July, 2002                                                        */
/***************************************************************************/

package lotos;

import lotos.*; 
/**
 * Priority Queue interface
 */

interface I_PriorityQueue
{
    /**if the queue is empty */
    boolean isEmpty();

    /** the minumum key */
    float minKey();
    /** the value corresponding to the minumum key */
    Object minValue();

    /** insert an object with key */
    void insert(float key, Object o);
    /** remove the object with the minumum key */
    Object removeMin();
    /** remove an existing object in the queue */
    void remove(Object o);

    /** determine if an object is in the queue */
    boolean contains(Object o);

    /** get the key of an object */
    float getKeyOf(Object o);
    /** set the key of an object */
    void setKeyOf(Object o, float key);
}
