
package lotos;

import lotos.*; 
class MobiRandomStep implements I_MobilityInterface
{
	private boolean MobilityEnabled;
	private float minX;
	private float maxX;
	private float minY;
	private float maxY;
	private float minZ;
	private float maxZ;
	private float speedX;
	private float speedY;
	private float speedZ;
	private float speed;
	
	private float prevTime = -1;
	
	public String toString(){ return "Random Motion";}


	MobiRandomStep()
	{
		init();
	}

	MobiRandomStep(float paramSpeed)
	{
		init();
		speed = paramSpeed*5;
	}
	
	void init()
	{
		speed = 5;
		minX = 0; maxX = 800;
		minY = 0; maxY = 800;
		minZ = 0; maxZ = 800;
		MobilityEnabled = true;
	}

	public void mobilityEnable()
	{
		MobilityEnabled = true;
	}

	public void mobilityDisable()
	{
		MobilityEnabled = false;
	}

	public Position move(float now, Position prev)
	{
		Position next;
		float x;	float y;	float z;

		float timeDifference = now - prevTime;
		
		if(MobilityEnabled && prevTime>=0)
		{
			//lotusDebug.errorln("TimeDiff="+timeDifference+" speed="+speed);
			
			x = prev.getX();
			y = prev.getY();
			z = prev.getZ();
			if(x < minX) x = minX;
			if(x > maxX) x = maxX;
			if(y < minY) y = minY;
			if(y > maxY) y = maxY;
			if(z < minZ) z = minZ;
			if(z > maxZ) z = maxZ;
			speedX = (float)(speed*2*(Math.random()-0.5));
			speedY = (float)(speed*2*(Math.random()-0.5));
			speedZ = (float)(speed*2*(Math.random()-0.5));
			x += speedX * timeDifference;
			y += speedY * timeDifference;
			z += speedZ * timeDifference;
			if(x < minX) { x = minX + (minX - x); speedX = -speedX; }
			if(x > maxX) { x = maxX + (maxX - x); speedX = -speedX; }
			if(y < minY) { y = minY + (minY - y); speedY = -speedY; }
			if(y > maxY) { y = maxX + (maxY - y); speedY = -speedY; }
			if(z < minZ) { z = minZ + (minZ - z); speedZ = -speedZ; }
			if(z > maxZ) { z = maxZ + (maxZ - z); speedZ = -speedZ; }
			next = new Position(x,y,0);
		}
		else
		{
			next = new Position(prev);
		}
		prevTime = now;
		return next;
	}
}
