package lotos;

import lotos.*; 
public class MobiReflectiveLinear implements I_MobilityInterface
{
	private boolean MobilityEnabled;
	public static float minX = 0;
	public static float maxX = 800;
	public static float minY = 0;
	public static float maxY = 800;
	public static float minZ = 0;
	public static float maxZ = 800;
	private float speedX;
	private float speedY;
	private float speedZ;
	private float speed;
	
	private float prevTime = -1;
	
	public String toString(){ return "Linear Motion";}
	
	MobiReflectiveLinear()
	{
		init();
	}

	MobiReflectiveLinear(float paramSpeed)
	{
		init();
		speed = paramSpeed;
		speedX = (float)(speed*2*(Math.random()-0.5));
		speedY = (float)(speed*2*(Math.random()-0.5));
		speedZ = (float)(speed*2*(Math.random()-0.5));
	}

	void init()
	{
		speed = 2;
		speedX = (float)(speed*2*(Math.random()-0.5));
		speedY = (float)(speed*2*(Math.random()-0.5));
		speedZ = (float)(speed*2*(Math.random()-0.5));
		
		MobilityEnabled = true;
	}

	public void mobilityEnable()
	{
		MobilityEnabled = true;
	}

	public void mobilityDisable()
	{
		MobilityEnabled = false;
	}

	public Position move(float now, Position prev)
	{
		Position next;
		float x;	float y;	float z;
		
		float timeDifference = now - prevTime;
		
		if(MobilityEnabled && prevTime>=0)
		{
			x = prev.getX();
			y = prev.getY();
			z = prev.getZ();
			if(x < minX) x = minX;
			if(x > maxX) x = maxX;
			if(y < minY) y = minY;
			if(y > maxY) y = maxY;
			if(z < minZ) z = minZ;
			if(z > maxZ) z = maxZ;
			x += speedX * timeDifference;
			y += speedY * timeDifference;
			z += speedZ * timeDifference;
			if(x < minX) { x = minX + (minX - x); speedX = -speedX; }
			if(x > maxX) { x = maxX + (maxX - x); speedX = -speedX; }
			if(y < minY) { y = minY + (minY - y); speedY = -speedY; }
			if(y > maxY) { y = maxX + (maxY - y); speedY = -speedY; }
			if(z < minZ) { z = minZ + (minZ - z); speedZ = -speedZ; }
			if(z > maxZ) { z = maxZ + (maxZ - z); speedZ = -speedZ; }
			next = new Position(x,y,z);
		}
		else
		{
			next = new Position(prev);
		}
		
		prevTime = now;
		
		return next;
	}
}

