/***************************************************************************/
/*       Lotos, an extensible overlay network simulator                    */
/*       MNG Group                                                         */
/*       University of Virginia                                            */
/*       July, 2002                                                        */
/***************************************************************************/
package lotos;

import lotos.*; 
/**
 * This class implements a physical node. It is mainly used by the topology
 * adaptors to store the topology description  information
 */
/*
 * revised by Guangyu Dong, Jan 6, 2004
 * to add mobility and wireless support
 */
public class PhyNodeProp {

    /** physical address, x */
    float x;
    /** physical address, y */
    float y;
    
    String mobility=null;
    float speed=0f;
	boolean wired=true;
	boolean wireless=false;
	
	public String getMobilityStr(){
		return mobility;
	}
	public  int getMobilityNum(){
		return getMobilityNum(mobility);
	}
		
	public static String getMobilityStr(int num){
		switch(num){
			case 0: return null;
			case 1: return "Random Motion";
			case 2: return "Linear Motion";
		}
		return null;
	}
	public static int getMobilityNum(String str){
		
		if(str==null)return 0;
		
		if(str.equals("Random Motion"))return 1;
		if(str.equals("Linear Motion"))return 2;
		
		return 0;
	}
	
	public PhyNodeProp( float xc,float yc, String mob, float sp, boolean wr, boolean wl){
		x=xc; y=yc;
		mobility=(mob);
		speed=sp;
		wired=wr;
		wireless=wl;
	}

    PhyNodeProp( int xc, int yc)
    {
	x=xc; y=yc;
    }

    public PhyNodeProp( float xc, float yc )
    {
        x = xc;
        y = yc;
    }

    int GetX() { return (int)x;}
    int GetY() { return (int)y;}

    float GetXF() { return x;}
    float GetYF() { return y;}
    void SetXF( float xf ) { x = xf; }
    void SetYF( float yf ) { y = yf; }
    
    
    
	void setSpeed(float paramSpeed)
	{		speed = paramSpeed;
	}
	void initMobility(String mobilityMode)
	{
		mobility=mobilityMode;
	}
}

