/***************************************************************************/
/*       Lotos, an extensible overlay network simulator                    */
/*       MNG Group                                                         */
/*       University of Virginia                                            */
/*       July, 2002                                                        */
/***************************************************************************/

package lotos.agent;

import lotos.*; 

/**
 * the two dimensional logical coorinates used for Delaunay Triangulation
 */

public class DTAddress {
    public float x;
    public float y;

    public DTAddress( float tx, float ty){
		x = tx;
		y = ty;
    }
    

    float getX(){ return x;}
    float getY(){ return y;}
    void setX(float sx){ x = sx;}
    void setY(float sy){ y = sy;}

    /**
     * the distance between this node and the other node
     * @param node  the other node
     */
    float distance( DTAddress node ){
        float dx = node.getX() - x;
        float dy = node.getY() - y;
        return (float)(Math.sqrt( dx*dx + dy*dy) );
    }
    public final String toString()
    {
        StringBuffer s = new StringBuffer();
        s.append((int)x);
        s.append(",");
        s.append((int)y);
        return s.toString();
    }

}
