
package lotos.agent;

import lotos.*; 
import hypercast.*;
import hypercast.DT.DT_LogicalAddress;
import hypercast.DT.DT_Node_BuddyList;
import hypercast.DT.GNP_Landmark;
import hypercast.events.NODE_ISSTABLE;
import hypercast.events.NODE_LEAVEOVERLAY;
import hypercast.events.NODE_LOGICALADDRESSCHANGED;
import hypercast.events.NODE_NEIGHBORHOODCHANGED;
import hypercast.events.NOTIFICATION_EVENT;
import hypercast.util.XmlUtil;

import java.awt.Color;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.Vector;


public class DTBuddyListAgent implements I_SimHyperCastAgent {
	
	simHCNetwork network;
	Random r = new Random();
	//DTAddressManager dtAddrMngr ;
	String prefix = "/Public/Node/DTBuddyList/";
	I_LogicalAddress laddr;
	I_OverlaySocket socket;
	I_PhysicalAddress paddr;
	
	//String prefix = "/Public/";
	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#getName()
	 */
	public String getName() {
		return "DTBuddyList";
	}
	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#setNetwork(simHCNetwork)
	 */
	public void setNetwork(simHCNetwork network) {
		this.network=network;
		//dtAddrMngr = new DTAddressManager(network, prefix);
	}
	
	public I_OverlaySocket createSocket(HyperCastConfig config, String info, I_PhysicalAddress phyaddr, I_ReceiveCallback callback, NotificationHandler handler, I_InterceptionCallback intercept) {
		I_OverlaySocket sock = config.createOverlaySocket(callback, handler, intercept);
		laddr = sock.getLogicalAddress();
		paddr = phyaddr;
		socket = sock;
		
		//LotosAdapterManager.addressPair.put(laddr.toString(), paddr);
		
		return sock;
	}
	
	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#getInfoForNode(hypercast.I_OverlaySocket)
	 */
	public String getInfoForNode(I_OverlaySocket node) {
		return "dtnode:"+node.getLogicalAddress();
	}
	
	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#getMenuItems()
	 */
	public String[] getMenuItems() {
		//TODO
		return new String[0];
	}

	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#menuFired(java.lang.String)
	 */
	public void menuFired(String menu) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#getColorForNode(hypercast.I_OverlaySocket)
	 */
	public Color getColorForNode(I_OverlaySocket node) {
		try {
			int state = Integer.valueOf((node.getStats(XmlUtil.createDocument(), XmlUtil.createXPath("/Socket/Node/State"))[0].getFirstChild().getNodeValue())).intValue();

			if(state==DT_Node_BuddyList.LEADER_INCOMPLETE || state==DT_Node_BuddyList.LEADER_STABLE)
				return Color.ORANGE;
			
		} catch (HyperCastStatsException hcse) {}
		
		return Color.YELLOW;
	}

	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#getShapeForNode(hypercast.I_OverlaySocket)
	 */
	public int getShapeForNode(I_OverlaySocket node) {
		//if(node instanceof DT_Node_BuddyList)
			return I_ProtocolInterface.shapeCircle;
		//else
			//return I_ProtocolInterface.shapeTriangle;
	}

	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#nodeRemoved(hypercast.I_OverlaySocket)
	 */
	public void nodeRemoved(I_OverlaySocket node) {
		//do nothing
		
	}

	

	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#needServers()
	 */
	public boolean needServers(HyperCastConfig config) {
		//return this.dtAddrMngr.needServers(config);
		return false;
	}

	/* (non-Javadoc)
	 * @see I_SimHyperCastAgent#getLabelForNode(hypercast.I_OverlaySocket)
	 */
	public String getLabelForNode(I_OverlaySocket node) {
		return "dtbuddy";
	}
	
	public I_LogicalAddress getLA() {
		return laddr;
	}
	public I_PhysicalAddress getPA() {
		return paddr;
	}
	public void finishConfig(HyperCastConfig config, PhysicalNode node) {
//		set up the coordinates
		XYAddress coords = node.getAddress();
		config.setTextAttribute(XmlUtil.createXPath(prefix+"Coords/FIXED/coordinate"), coords.getX()+","+coords.getY());
		/*
		String addrtype = config.getTextAttribute(XmlUtil.createXPath(prefix+"Buddy/UnderlayAddress"));
		String addrstr = config.getTextAttribute(XmlUtil.createXPath(prefix+"Buddy/UnderlayAddress/"+addrtype));
		SimPhysicalAddress addr = new SimPhysicalAddress(addrstr);
		if(LotosAdapterManager.searchAddress(addr) == null) {
			config.setTextAttribute(XmlUtil.createXPath("/Public/NodeAdapter/NodeAdptLotos/PhysicalAddress"), addr.toString());
			config.setTextAttribute(XmlUtil.createXPath("/Public/SocketAdapter/ScktAdptLotos/PhysicalAddress"), addr.toString());
			LotosAdapterManager.addr_list.put(addr.toString(), node);
			
		}
		*/
	}
}
