/***************************************************************************/
/*       Lotos, an extensible overlay network simulator                    */
/*       MNG Group                                                         */
/*       University of Virginia                                            */
/*       July, 2002                                                        */
/***************************************************************************/
package lotos.event;

import lotos.*; 
/**
 * This class implements the simulation event
 */
public class SimEvent
{
    /** time of the event */
    /** changed to "long" by Guangyu to get precise microsecond level time */
    /** 1000000 = 1sec */
    public long time;

    public I_EventHandler target;
    
    /** type of the message */
    int event_type;

    public final static int MESSAGE_EVENT = 1;
    public final static int PROTOCOL_TIMER_EVENT = 2;
    public final static int MAC_TIMER_EVENT = 3;
		
    public SimEvent(long t, I_EventHandler reciever, int et)
    {
        setTime(t);
        target = reciever;
        event_type = et;
    }
    
    public long getTime()
    {
    	/* get float time*/
        return time;
    }
    
	/* set event time with real seconds */
    public void setTime(long t)
    {
        time = t;
    }
    
    public void setTarget(I_EventHandler rec) {
    	target = rec;
    }
/*
   
*/
    public int eventType()
    {
        return event_type;
    }
    
    
}
