package lotos.history;

import lotos.SimEventProcessor;

public class ConsoleOutputHistoryEvent implements EventHistoryEntry {
	float timestamp;
	String message, node;
	
	public ConsoleOutputHistoryEvent(long timestamp, String nodeID, String output) {
		node = nodeID;
		message = output;
		this.timestamp = timestamp/SimEventProcessor.TIME_PER_SEC;		
	}
	
	public String getDetails() {
		return message;
	}

	public String getSummary() {

		return "Console Output";
	}

	public float getTimestamp() {
		return timestamp;
	}

	public String logEntry() {
		
		String entry = "<event node=\""+node+"\" type=\"ConsoleOutput\">\n";
		entry+="\t<output>"+replaceSpecialChars(message)+"</output>\n";
		entry+="</event>";
		return entry;
	}
	private String replaceSpecialChars(String str) {
		String tmp = str.replaceAll("<", "&lt;");
		tmp = tmp.replaceAll(">", "&gt;");
		return tmp;
	}
}
