package lotos.history;

import hypercast.events.NOTIFICATION_EVENT;
import lotos.SimEventProcessor;


public class NotificationHistoryEntry implements EventHistoryEntry{
	float timestamp;
	NOTIFICATION_EVENT notification;
	
	public NotificationHistoryEntry(long timestamp, NOTIFICATION_EVENT notification, String nodeID){
		this.timestamp = timestamp/SimEventProcessor.TIME_PER_SEC;
		this.notification = notification;
	}

	/* (non-Javadoc)
	 * @see EventHistoryEntry#getTimestamp()
	 */
	public float getTimestamp() {
		return timestamp;
	}

	/* (non-Javadoc)
	 * @see EventHistoryEntry#getSummary()
	 */
	public String getSummary() {
		return "Notification Event" ;
	}

	/* (non-Javadoc)
	 * @see EventHistoryEntry#getDetails()
	 */
	public String getDetails() {
		String details = "";
		details += "Type = " +notification.getClass().getName() +"\n\n";
		details += "Occurred at " + ((float)notification.getTimestamp()/1000) +"s\n\n";
		details += "Information = " + notification.getInfo() +"\n\n";
		
		return details;
	}

	public String logEntry() {
		// TODO Auto-generated method stub
		return null;
	}
}