package lotos.history;
import lotos.SimEventProcessor;

public class TimerHistoryEntry implements EventHistoryEntry{
	float timestamp;
	boolean sent;
	Object timer;
	float delay;
	String node;
	
	public TimerHistoryEntry(long timestamp, boolean sent, Object timer, float delay, String nodeID){
		this.timestamp = timestamp/SimEventProcessor.TIME_PER_SEC;
		this.sent = sent;
		this.timer = timer;
		this.delay = delay;
		node = nodeID;
	}
	public float getTimestamp(){
		return timestamp;
	}
	public String getSummary(){
		if(sent){
			return "Timer set delay="+delay+"s"; 
		}else{
			return "Timer expires";
		}
	}
	/* (non-Javadoc)
	 * @see EventHistoryEntry#getDetails()
	 */
	public String getDetails() {
		String details = "";
		details += "Type = "+timer.getClass().getName() +"\n\n";
		details += "Timer.toString() = " +timer +"\n\n";
		if(sent)
			details += "Delay = "+delay+"s";
		
		return details;
	}
	public String logEntry() {
		String entry = "<event node=\""+node+"\" type=\"";
		if(sent) {
			entry+="TimerSet\">\n";
			
		} else {
			entry+="TimerExpire\">\n";
		}
		entry+="\t<timestamp>"+timestamp+"</timestamp>\n";
		entry+="\t<delay>"+delay+"</delay>\n";
		entry+="</event>";
		
		return entry;
	}
	
}
