package lotos.nodeappl;

import hypercast.*;

import java.awt.Color;

import org.w3c.dom.Document;

import lotos.*;
import lotos.event.*;

public class TTCP_Receiver extends LotosHyperCastAppl{

	long startReceive;
	long endReceive;
	int packetsRec;
	int packetSize;
	int packetsSent;
	Object timeout = new Object();
	int timeoutTime = 3000000;
	Thread myThread;
	boolean running;
	boolean started;
	
	public TTCP_Receiver(HyperCastConfig config, Document applConfig) {
		super(config);
	}
	
	public Color getColor() {
		return Color.BLUE;
	}

	public int getShape() {
		// TODO Auto-generated method stub
		return 0;
	}

	public void receiveEvent(SimEvent se) {
		if(!running)
			return;
		if(SimEventProcessor.getSimTime() - endReceive < timeoutTime) {
			se.setTime(SimEventProcessor.getSimTime() + timeoutTime);
			SimEventProcessor.insertEvent(se);
			return;
		}
		long throughput = (long)((double)packetsRec * packetSize / (endReceive - startReceive) * 1000000);
		System.err.println("Packets received: "+packetsRec + " out of "+packetsSent + " : loss rate = "+(1-(float)packetsRec/packetsSent));
		System.err.println("measured throughput: "+throughput + "bytes/second");
		

	}

	public void restart() {
		packetsRec = 0;

	}

	public void start() {
		running = true;
		packetsRec = 0;
		started = false;
		System.out.println("Waiting to receive packets");
	}

	public void stop() {
		running = false;
	}
	public void ReceiveCallback (final I_OverlayMessage message) {
		byte[] payload = message.getPayload();
		if(payload.length==0)
			return;
		if(payload[0]==0) { //signals start of sending
			if(started)
				return;
			started = true;
			System.out.println("Received signal from sender");
			packetsSent = ByteArrayUtility.toInteger(payload, 1);
			packetSize = ByteArrayUtility.toInteger(payload, 5);
			packetsRec = 0;
			SimEventTimer ending = new SimEventTimer(SimEventProcessor.getSimTime() + timeoutTime, this, timeout);
			SimEventProcessor.insertEvent(ending);
			startReceive = -1;
			message.setHopLimit((byte) 200);
			sendToNode(message, message.getSourceAddress());
			endReceive = SimEventProcessor.getSimTime();
			
		} else { //data packet
			if(startReceive <0 )
				startReceive = SimEventProcessor.getSimTime();
			packetsRec++;
			endReceive = SimEventProcessor.getSimTime();
			
		}
		
	}
	private void handleOther() {
		
	}
}
