package lotos.nodeappl;

import java.awt.Color;

import org.w3c.dom.Document;

import lotos.*;
import lotos.event.*;
import hypercast.*;

public class TTCP_Sender extends LotosHyperCastAppl implements Runnable {

	long waitBeforeSending = 10000000; //wait 10 seconds before sending
	int numPackets;
	int packetSize;
	I_LogicalAddress receiver;
	Thread myThread;
	boolean running;
	int sendInterval;
	Object sendTimer = new Object();
	Object startTimer = new Object();
	byte[] packet;
	
	public TTCP_Sender(HyperCastConfig config, Document applConfig) {
		super(config);
	}
	
	public Color getColor() {
		return Color.MAGENTA;
	}

	public int getShape() {
		return 0;
	}
	int sent;
	public void receiveEvent(SimEvent se) {
		if(((SimEventTimer)se).getIndex()==sendTimer && running) {
			I_OverlayMessage msg = createMessage(packet);	
			msg.setHopLimit((short)255);
			sendToNode(msg, receiver);
			sent++;
			if(sent%20==0)
				System.out.print(".");
			if(sent%500 == 0)
				System.out.println();
			if(sent<numPackets) {
				se.setTime(SimEventProcessor.getSimTime()+sendInterval);
				SimEventProcessor.insertEvent(se);
			} else {
				System.out.println("done");
				running = false;
			}
		} else if(((SimEventTimer)se).getIndex() == startTimer && running)
			new Thread(this, "TTCP_Sender").start();
		
		
	}

	public void restart() {
		SimEventProcessor.clearEvent(new SimEventTimer(SimEventProcessor.getSimTime()+waitBeforeSending, this, startTimer));
		start();
	}

	public void start() {
		numPackets = 20000;
		packetSize = 512;
		sendInterval = 20;
		
		receiver = null;
		running = true;
		sent=0;
		SimEventProcessor.insertEvent(new SimEventTimer(SimEventProcessor.getSimTime()+waitBeforeSending, this, startTimer));
	}

	public void stop() {
		running = false;
		if(myThread != null)
			myThread.interrupt();
	}
	
	public void run() {		
		myThread = Thread.currentThread();
		//the packet that will be sent repeatedly to measure throughput
		packet = new byte[packetSize];
		packet[0] = 1;	
		//the information packet to start the receivers
		byte[] starter = new byte[9];
		starter[0] = 0;
		System.arraycopy(ByteArrayUtility.toByteArray(numPackets), 0, starter, 1, 4);
		System.arraycopy(ByteArrayUtility.toByteArray(packetSize), 0, starter, 5, 4);
		I_OverlayMessage startmsg = createMessage(starter);
		startmsg.setHopLimit((short)10);
		sendToAll(startmsg);
		
		try {
			Thread.sleep(20000);
			System.err.println("Error: could not locate ttcp receiver");
		} catch (InterruptedException ie) {
			if(!running)
				return;
			System.out.println("Sending packets to "+receiver.toString());
			SimEventProcessor.insertEvent(new SimEventTimer(SimEventProcessor.getSimTime()+1, this, sendTimer));
		}
		//running = false;
	}
	
	public void ReceiveCallback (final I_OverlayMessage message) {
		if(receiver != null || message.getSourceAddress().equals(getLogicalAddress()))
			return;
		receiver = message.getSourceAddress();
		lotosDebug.println("TTCP Sender at " + getLogicalAddress()+ " recieved reply from "+receiver.toString());
		myThread.interrupt();
	}
	
	private void handleOther(final Throwable throwable) {
		
	}

}
